#!/usr/bin/perl
# export-lib.pl
# Common functions for the linux exports file

##################################################################
#
#  (C) JRCP - www.winlinux.net
#
#  This program is distributed under the GPL (www.gnu.org)
#
#  Version: 1.0
#  Date: 05/26/2000
#
#  Authors: Vinicius Silva
#
#
##################################################################

do '../web-lib.pl';
&init_config();


sub get_video_cards
{
return @list_vcards_cache if (@list_vcards_cache);
$count = 0;
open(DISPLAY_FILE, $config{'vcards_file'});
while(<DISPLAY_FILE>) {

        s/#.*$//g;
        if( /^(.+):(.+):(.+)$/ )
        {
          $list_vcards_cache[$count] = "$1:$2:$3";
          chop $list_vcards_cache[$count];
          $count++;
        }
}
close(DISPLAY_FILE);
return @list_vcards_cache;
}

sub get_video_modes
{
return @list_vmodes_cache if (@list_vmodes_cache);
$count = 0;
open(DISPLAY_FILE, $config{'vmode_file'});
while(<DISPLAY_FILE>) {
        s/#.*$//g;
        if( /^(.+):(.+)$/ ) {
          $list_vmodes_cache[$count] = "$1:$2";
          chop $list_vmodes_cache[$count];
          $count++;
        }
}
close(DISPLAY_FILE);
return @list_vmodes_cache;
}

sub get_current_vmode
{
  return $curr_vmode if ($curr_vmode);

  open(XCONFIG_FILE, $config{'xconfig_file'});
  while(<XCONFIG_FILE>) 
  {
    if( /^(Modeline.+)$/ )
    {
      $curr_vmode = $1;
      break;
    }
  }
  close(XCONFIG_FILE);
  return $curr_vmode;
}

sub change_xconfig_file
{
  local
    $modeline,
    $modename,
    $bpp,
    $xserver,
    $doption,
    $driver,
    $dvname;

  $modeline = $_[0];
  $modename = $_[1];
  $bpp = $_[2];
  $xserver = $_[3];
  $driver = $_[4];
  $dvname = $_[5];

  if( $xserver eq "" || $dvname eq "" || $modeline eq "" || $bpp eq "" || $modename eq "" )
  {
    print("<font color=red>");
    print($text{'server_error'});
    print ("</font>");
    exit;
  }


#  $modename = &trim( $modename );

  open(XCONFIG_FILE, $config{'xconfig_file'});
  $tempfile = &tempname();
  open(TMP_FILE, ">>$tempfile" );

while(<XCONFIG_FILE>)
  {

    if( /#.*$/ )
    {
      print TMP_FILE $_;
    }
    elsif( /Section\s"Files"/ )
    {
      $section = 1;
      print TMP_FILE $_;
    }
    elsif( /Section\s"Keyboard"/ )
    {
      $section = 2;
      print TMP_FILE $_;
    }
    elsif( /Section\s"Pointer"/ )
    {
      $section = 3;
      print TMP_FILE $_;
    }
    elsif( /Section\s"Device"/ )
    {
      $section = 4;
      print TMP_FILE $_;
    }
    elsif( /Section\s"Monitor"/ )
    {
      $section = 5;
      print TMP_FILE $_;
    }
    elsif( /Section\s"Screen"/ )
    {
      $section = 6;
      print TMP_FILE $_;
    }
    elsif( /EndSection/ )
    {
      if ( $section == 4 )
      {
        if ( $in{'no_accel'} eq "on" )
        {
           print TMP_FILE "Option \"no_accel\"\n";
        }
        if ( $in{'sw_cursor'} eq "on" )
        {
           print TMP_FILE "Option \"sw_cursor\"\n";
        }
      }
      $section = 0;
      print TMP_FILE $_;
    }
#Write config lines
    elsif( /^(Mode.ine.+)$/ )
    {
      print TMP_FILE "$modeline\n";
    }
    elsif( /\s*Modes.+/ )
    {
      print TMP_FILE "Modes \"$modename\"\n";
    }
    elsif ( /\s*Depth.+/ )
    {
      print TMP_FILE "Depth $bpp\n";
    }
    elsif ( /\s*Driver.+/ )
    {
      print TMP_FILE "Driver \"$driver\"\n";
    }
    elsif (( /\s*VendorName.+/ ) && ($section == 4) )
    {
      print TMP_FILE "VendorName \"$dvname\"\n";
    }
    elsif (( /\s*Option\s+(".+")/ ) && ($section == 4) )
    {
      if (uc($1) eq ("NO_ACCEL"))
      {
         if ($in{'no_accel'} eq "on" )
         {
           print TMP_FILE "Option \"no_accel\"\n";
           $in{'no_accel'} = 2;
         }
      }
      if (uc($1) eq ("SW_CURSOR"))
      {
         if ($in{'sw_cursor'} eq "on" )
         {
           print TMP_FILE "Option \"sw_cursor\"\n";
           $in{'sw_cursor'} = 2;
         }
      }
    }
    elsif (( /\s*BoardName.+/ ) && ($section == 4) )
    {
      print TMP_FILE "BoardName \"$dvname\"\n";
    }
    elsif ( /(.+)/ )
    {
      print TMP_FILE $_ ;
    }
  }
  close(XCONFIG_FILE);
  close(TMP_FILE);
  system("/bin/cp -f $config{'xconfig_file'} $config{'xconfig_file_bak'}");
  system("/bin/mv -f $tempfile $config{'xconfig_file'}");

#should verify if xserver exist

    open(TMP_FILE, ">/usr/X11R6/bin/X" );
    print TMP_FILE  "#!/bin/sh\n\n";
    print TMP_FILE  "exec /usr/X11R6/bin/$xserver\n";
    close(TMP_FILE);

}


sub get_all_config
{
  local $name;
  local $value;
  local $section = 0;

  open(XCONFIG_FILE, $config{'xconfig_file'});

SWITCH:  while(<XCONFIG_FILE>)
  {
    {
      /#.*$/ && do { next SWITCH; };
      /Section\s"Files"/ && do { $section = 1; next SWITCH; };
      /Section\s"Keyboard"/ && do { $section = 2; next SWITCH; };
      /Section\s"Pointer"/ && do { $section = 3; next SWITCH; };
      /Section\s"Device"/ && do { $section = 4; next SWITCH; };
      /Section\s"Monitor"/ && do { $section = 5; next SWITCH; };
      /Section\s"Screen"/ && do { $section = 6; next SWITCH; };
      /EndSection/ && do { $section = 0; next SWITCH; };
    }

    if( /(\w+)\s+(".+")/ )
    {
      $name = $1;
      $value = $2;
    }
    else
    {
      ( $name, $value ) = split;
    }

#    print "$name=$value\n<br>";
    if ($section == 2)
    {
      $xf_keyboard{$name} = $value;
    }
    elsif ($section == 3)
    {
      $xf_pointer{$name} = $value;
    }
    elsif ($section == 4)
    {
      if (uc($name) eq "OPTION")
      {
        $xf_device{uc($name."_".substr($value,1,length($value)-2))} = 1;
      }
      else
      {
        $xf_device{$name} = $value;
      }
    }
    elsif ($section == 5)
    {
      $xf_monitor{$name} = $value;
    }
    elsif ($section == 6)
    {
      $xf_screen{$name} = $value;
    }

  }
  close(XFCONFIG_FILE);
}
